Status: Closed Start date: 30 Jun 2017

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: Safety Estimated time: 1.11 hour

Target version: CoCoALib-0.99850 Spent time: 1.15 hour

Description

The functions IsDivisible (with 3 args) and GCDQuot have OUT args.

They throw ERR::MixedRings if any of the OUT params belongs to another ring.

Is this reasonable/correct?

Discuss.

This outline example will give a MixedRings error (assuming P is not ZZ)

   RingElem f(P);

   RingElem g(P);

   ...

   RingElem quot; // in ZZ by default

   if (!IsDivisible(quot, f,g)) CoCoA_ERROR(...);

Related issues:

Related to CoCoA-5 - Feature #7: Automatic mapping between (some) rings Resolved 20 Oct 2011

Related to CoCoALib - Design #1500: IsDivisible in a field? Closed 05 Oct 2020

History

#1 - 30 Jun 2017 14:14 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 0 to 10

I would expect the following two code excerpts to be essentially equivalent:

RingElem quot; // 0 in ZZ

bool DoesDivide = IsDivisible(f,g);

if (!DoesDivide) { ... }

quot = f/g; // wasteful recomputation

 

RingElem quot; // 0 in ZZ

if (!IsDivisible(quot, f,g)) { ... }

 

However, the second, neater approach currently gives an error if the ring of quot is wrong.  This design was probably inspired by the old idea of not

letting RingElem variables change ring.
#2 - 30 Jun 2017 14:19 - John Abbott

I wonder which other fns are affected?

Presumably we should decide the same way for all of them...

When I have time, I shall search through the source code to see which other fns must be checked.

GcdQuot  (done, I think)

operator+= etc. (in ring.C)

#3 - 06 Nov 2017 14:03 - John Abbott

- Target version changed from CoCoALib-0.99560 to CoCoALib-0.99600

#4 - 02 Aug 2018 17:05 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99600 to CoCoALib-0.99650 November 2019

#5 - 23 Sep 2019 12:57 - John Abbott

- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-0.99700

#6 - 08 Jan 2020 23:00 - John Abbott

- Target version changed from CoCoALib-0.99700 to CoCoALib-0.99800

#7 - 20 Jun 2020 21:25 - John Abbott

- Related to Feature #7: Automatic mapping between (some) rings added

#8 - 27 Oct 2020 10:22 - John Abbott

- Related to Design #1500: IsDivisible in a field? added

#9 - 27 Oct 2020 15:26 - John Abbott

- % Done changed from 10 to 20

This issue is a generalized version of issue #1500 (which itself is concerned with the example in comment 1 of this issue).

My current thinking is that the ring to which an OUT parameter belongs should now be ignored, and the result simply put into the correct ring

(and no MixedRings exception thrown).

Hopefully there are not too many fns with OUT params (of RingElem type).  It seems that I was creating a list in comment 2 above.

#10 - 27 Oct 2020 19:24 - John Abbott

- % Done changed from 20 to 30

#11 - 28 Jan 2022 13:06 - John Abbott

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#12 - 08 Mar 2024 17:45 - John Abbott

Verbal discussion: do not give MixedRings error.  So that the two code excerpts in comment 1 are equivalent.

JAA will check through all cases... (yawn!)
#13 - 16 Mar 2024 21:20 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 30 to 90

This seems to have been done already, at least mostly.  So it has morally been in feedback for several month, at least.

Should we include some tests?  Well, we should; but who has any desire to do so?

#14 - 21 Mar 2024 20:29 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 1.11 h

I'm too lazy to track down all the functions which ought to be tested, and then to write the corresponding tests.

So closing without writing any tests... if we get burned later then we can write some tests (Microsoft approach).
